# Copyright (C) 2017-2019  Lars Wirzenius
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import ick2


class WorkerAPI(ick2.ResourceApiBase):  # pragma: no cover

    def __init__(self, state):
        super().__init__('workers', state)

    def get_resource_name(self, resource):
        return resource['worker']

    def _get_client_id(self, **kwargs):
        claims = kwargs.get('claims', {})
        client_id = claims.get('aud')
        if client_id is None:
            raise ick2.ClientIdMissing()
        return client_id

    def create(self, body, **kwargs):
        client_id = self._get_client_id(**kwargs)
        body['worker'] = client_id
        kwargs['token'] = self._token_getter.get_token()
        return super().create(body, **kwargs)
